from typing import Callable
from server import OlympicsServer


class Publisher:
    def __init__(self, server: OlympicsServer):
        pass

    def publish(self, topic: str, message: str, qos: int):
        pass


class Subscriber:
    def __init__(self, server: OlympicsServer, callback: Callable):
        pass

    def subscribe(self, topic: str):
        pass


class Client:
    def __init__(self, server: OlympicsServer):
        self.server = server

    def publish(self, topic: str, message: str, qos: int):
        publisher = Publisher(self.server)
        publisher.publish(topic, message, qos)

    def subscribe(self, topic: str, callback: Callable):
        subscriber = Subscriber(self.server, callback)
        subscriber.subscribe(topic)
